/* for popen on Solaris */
#ifdef SunOS
#ifndef __EXTENSIONS__
#  define __EXTENSIONS__
#endif
#else
#ifndef _POSIX_C_SOURCE
#  define _POSIX_C_SOURCE 2
#endif
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "help.hpp"

static const char help_string[] =
{
  85, 115, 97, 103, 101, 58, 10, 
  32, 32, 32, 32, 114, 97, 121, 103, 101, 110, 32, 111, 112, 116, 105, 111, 110, 115, 10, 
  10, 
 0
};


int
help( void )
{
  const char *pager;
  FILE *pipe;

  if ( ! isatty( STDOUT_FILENO ) )
    fputs( help_string, stdout );
  else
  {
    if ( NULL == ( pager = getenv( "PAGER" )) )
      pager = "more";

    if ( NULL == ( pipe = popen( pager, "w" ) ) )
      return 1;

    fputs( help_string, pipe );
    pclose( pipe );
  }
  return 0;
}
